##create

element createion

##installation

	npm install create.js

##usage

```javascript
create[tagName](options)
```

example

```javascript
var element = create.div({
	classes: ['class', 'class2'], 
	id: 'identifier', 
	content: '<div class="thing"></div>'
});
```

returns

```html
<div class="class class2" id="identifier"><div class="thing"></div></div>
```

calls to create can be nested

```javascript
var element = create.div({
	classes: ['class', 'class2'], 
	id: 'identifier', 
	content: create.p({content:'hi there'})
});
```

returns

```html
<div class="class class2" id="identifier"><p>hi there</p></div>
```

content can also be set as a function. define context in options to declare the param the function recieves.

```javascript
var element = create.div({
	classes: ['class', 'class2'], 
	id: 'identifier', 
	context: { things: [ 'thing1', 'thing2' ] }, 
	content: function(context) {
		var fragment = create.fragment();
		context.things.forEach(function(thing) { 
			var p = create.p({content:thing});
			fragment.appendChild(p);
		});
		return fragment;
	}
});
```

returns

```html
<div class="class class2" id="identifier">
	<p>thing1</p>
	<p>thing2</p>
</div>
```

create.fragment with no params creates and returns an empty document fragment.


pass attributes to options to set on returned element.

additional options: 

classes property can be a string or list. to add classes to element.