var utils = require('./lib/utils');
var types = utils.types;

var tags = ['a', 'abbr', 'address', 'area', 'article', 'aside', 'audio', 'b', 'base', 'bdi', 'bdo', 'blockquote', 'body', 'br', 'button', 'canvas', 'caption', 'cite', 'code', 'col', 'colgroup', 'content', 'data', 'datalist', 'dd', 'del', 'details', 'dfn', 'dialog', 'div', 'dl', 'dt', 'em', 'embed', 'fieldset', 'figcaption', 'figure', 'footer', 'form', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'head', 'header', 'hr', 'html', 'i', 'iframe', 'img', 'input', 'ins', 'kbd', 'keygen', 'label', 'legend', 'li', 'link', 'main', 'map', 'mark', 'menu', 'menuitem', 'meta', 'meter', 'nav', 'noscript', 'object', 'ol', 'optgroup', 'option', 'output', 'p', 'param', 'picture', 'pre', 'progress', 'q', 'rp', 'rt', 'ruby', 's', 'samp', 'script', 'section', 'select', 'shadow', 'small', 'source', 'span', 'strong', 'style', 'sub', 'summary', 'sup', 'table', 'tbody', 'template', 'textarea', 'tfoot', 'th', 'thead', 'time', 'title', 'tr', 'track'];

var creat = {};

tags.forEach(function(tag) {
	creat[tag] = function(options) {
		var options = options || {};
		var element = document.createElement(tag);
		var context = options.context || {};
		var escape = options.escape || true;
		var classes = options.classes || '';
		delete options['context'];
		delete options['escape'];

		if (classes) {
			utils.add(element, classes);
			delete options['classes'];
		}

		if (options.content) {
			var content = options.content;

			if (types.isElement(content)) {
				element.appendChild(content);
			} else

			if (types.isString(content)) {
				element.innerHTML = content;
			} else

			if (types.isFunction(content)) {
				children = content.call(null, context);
				element.appendChild(children);
			} else

			if (types.isArray(content)) {

				for (var i = 0, l = content.length; i < l; i++) {
					var arg = content[i];
					if (types.isElement(arg)) {
						element.appendChild(arg);
					} else if (types.isFunction(arg)) {
						arg.call()
					}
				}

			}

			delete options['content'];
		}

		utils.add(element, options);
		
		return element;
	};
});

creat.fragment = function() {
	if (!arguments.length) return document.createDocumentFragment();
};

module.exports = creat;